within GNU_ScientificLibrary.UsersGuide;
class Overview "Overview of GNU GSL Library"
  extends Modelica.Icons.Information;

 annotation (Documentation(info= "<html><head></head><body><p>Many physical applications require the solving of PDEs, rendering Differential-Algebraic solvers ill-suited for the general task. However, such problems sometimes exhibit symmetries, leading a way to change the PDEs to a system of coupled ODEs via canonical transformations and separability (see, e.g., §5.1 of Morse and Feshbach, Methods of Theoretical Physics, 1953). This transformation of the problem usually involves a choice of specific coordinates, and along these new dimensions, Special Functions. Sometimes symmetries involve degrees of freedom in an \"internal\" space, as in some forms of media (e.g., degenerate matter). Access to a larger mathematical library could also improve simulation preconditioning, as well as intermediate- and post-simulation analysis. An extension of Modelica's mathematical functions (here with the GNU Scientific Library) is therefore thought to be potentially useful.</p><p>The primary tools of this library are contained in the Functions Package. The file structure of the packages mirrors the GNU GSL file structure to assist in locating files between Modelica and GSL source code.</p><p>Thus far, emphasis has been placed upon the use of GSL's special functions (further GSL capabilities are possible and may be forthcoming). The functions have also been packaged into Blocks for direct use in Modelica Connection Tools, like OMEdit and Dymola. Some examples are also provided to show usage of the function blocks. In some cases, additional, related blocks (associated DEs, asymptotic forms, numerical inverters) have been created for further support.</p><p></p><div class=\"textDoc\" style=\"color: rgb(0, 0, 0); font-family: -webkit-standard; font-style: normal; font-variant-caps: normal; font-weight: normal; letter-spacing: normal; orphans: auto; text-align: start; text-indent: 0px; text-transform: none; white-space: normal; widows: auto; word-spacing: 0px; -webkit-tap-highlight-color: rgba(0, 0, 0, 0.4); -webkit-text-stroke-width: 0px;\"><p style=\"font-family: 'DejaVu Sans Mono'; font-size: 12px;\"></p></div><p></p><div class=\"htmlDoc\" style=\"font-family: 'DejaVu Sans Mono'; font-size: medium; color: rgb(0, 0, 0); font-style: normal; font-variant-caps: normal; font-weight: normal; letter-spacing: normal; orphans: auto; text-align: start; text-indent: 0px; text-transform: none; white-space: normal; widows: auto; word-spacing: 0px; -webkit-tap-highlight-color: rgba(0, 0, 0, 0.4); -webkit-text-stroke-width: 0px;\"><p>This Modelica package is free software and the use is completely at your own risk; it can be redistributed and/or modified under the terms of the GNU General Public License (GPL). For license conditions visit https://www.gnu.org/copyleft/gpl.html.</p></div>
</body></html>"));
end Overview;